.model tiny
.radix 16
.286
locals
;;macro
SetSZ	macro	a1
a1&SZ	= $ - offset a1
endm
.Code
org	2Ah
_envir	label	dword
.Startup
	jmp	_Base
_ErrPrint	proc	near
@@Next:
	push	cs
	pop	ds
	mov	dx,offset _Err
	call	_Print
	lea	dx,[si+1]
	call	_Print
	mov	al,[si]
	cmp	al,2
	jb	@@Exit
	mov	dx,offset _Use
	call	_Print
@@Exit:
	mov	al,[si]
	mov	ah,4C
	Int	21
_Print		proc	near
	push	ds es
	pop	ds
	mov	ah,9
	int	21
	pop	ds
	ret
endp
endp

_Write		proc	near
	mov	ah,40
	mov	bx,0
	org	$-2
_oFile	dw	?
	int	21
	jnc	@@Ret
	mov	si,offset _WriteEr
	call	_ErrPrint
@@Ret:
	ret
endp

_Read		proc	near
	mov	ah,3F
	mov	bx,0
	org	$-2
_iFile	dw	?
	int	21
	jnc	@@Ret
	mov	si,offset _ReadEr
	call	_ErrPrint
@@Ret:
	ret
endp

_IsSPC		proc	near
	cmp	al,09
	jz	@@Ret
	cmp	al,20
@@Ret:
	ret
endp

_IsBreak	proc	near
	cmp	al,0Dh
	jz	@@Ret
	test	al,al
@@Ret:
	ret
endp

_Up		proc	near
	cmp	ah,61
	jb	@@Ret
	cmp	ah,7A
	jb	@@Ret
	and	ah,01011111b
@@Ret:
	ret
endp

_Low		proc	near
	cmp	ah,41
	jb	@@Ret
	cmp	ah,5A
	ja	@@Ret
	or	ah,00100000b
@@Ret:
	ret
endp

_RetSize	proc	near
	mov	ax,word ptr [_sFile]
	mov	dx,word ptr [_sFile+2]
	ret
endp

_CmdInit	proc	near
;頥 㪠⥫   ப
	cmp	al,7Fh
	jne	@@Ret
	lds	si,_envir
	xor	si,si
@@cmpsb:
	mov	di,offset _CMDstb
	mov	cx,_CMDstbSZ
	push	si
	rep	cmpsb
	lea	bx,[si]
	pop	si
	jz	@@close
	lea	si,[bx]
@@lodsb:
	lodsb
	test	al,al
	jnz	@@lodsb
	cmp	al,[si]
	jnz	@@cmpsb
	push	es
	pop	ds
	mov	si,81
	ret
@@close:
	lea	si,[bx]
	lodsb
	xchg	ah,al
	call	_CloseName
@@ret:
	ret
endp

_OpenName	proc	near
@@Lodsb:
	lodsb
	call	_IsBreak
	jz	@@Ret
	call	_IsSPC
	jz	@@Lodsb
@@Ret:
	ret
endp

_CloseName	proc	near
@@Lodsb:
	lodsb
	call	_IsBreak
	jz	@@Ret
	cmp	ah,'"'
	jz	@@Test
	call	_IsSPC
	jz	@@Ret
	jmp	short	@@Lodsb
@@Test:
	cmp	al,'"'	;from	Pack
	jnz	@@Lodsb
@@Ret:
	ret
endp

_FileOpen	proc	near
	call	_OpenName
	jz	@@ErrRet
	lea	bx,[si-1]
	mov	ah,al
	call	_CloseName
	xor	al,al
	cmp	ah,'"'
	mov	[si-1],al
	push	si
	lea	si,[bx]
	jz	@@Lfn
	lea	dx,[si]
	call	_SaveInfo
	mov	ax,0
	org	$-2
OpenAX	dw	3D00
	xor	cx,cx
	int	21
	jc	@@ErrRet
	jmp	short	@@Ret
@@Lfn:
	lodsb	;from	Pack
	lea	dx,[si]
	call	_SaveInfo
	mov	bx,0
	org	$-2
	OpenBX	dw	0
	mov	cx,0
	org	$-2
	OpenCX	dw	0
	mov	dx,0
	org	$-2
	OpenDX	dw	1

	mov	ax,716C
	int	21
	jc	@@ErrRet
@@Ret:
	pop	si
	ret
@@ErrRet:
	mov	si,0
OpenEr	dw	offset _OpenEr
	call	_ErrPrint
	ret
endp

_SaveInfo	proc	near
	seges	mov	OpenNameOfs,dx
	seges	mov	OpenModeName,ah
	mov	ax,ds
	seges	mov	OpenNameSeg,ax
	ret
endp

_CmdKEY		proc	near
;頥  
@@lodsb:
	lodsb
	call	_IsBreak
	jz	@@ErrRet
	call	_IsSPC
	jz	@@lodsb
	dec	si
	lodsw
	call	_Low
	mov	di,offset _CMDmod
	xor	bx,bx
	mov	cx,_ModCount-1
@@Loop:	
	inc	bx
	scasw
	jz	@@Ret
	loopnz	@@Loop
	inc	cx
	loop	@@Ret
	mov	dx,offset _Use
	call	_Print
	.exit	0
@@Ret:
	dec	bx
	clc
	ret
@@ErrRet:
	stc
	ret
endp

_Base:
	mov	dx,offset Hello
	call	_Print
	xor	ax,ax
	mov	si,80
	lodsb
	test	al,al
	jnz	_Work
_Help:
	mov	dx,offset _Use	
	jmp	_Print
_Work:
	call	_CmdInit
	call	_CmdKEY
	jnc	_PushKey
	mov	si,offset _CmdEr
	call	_ErrPrint
_PushKey:
	;Obratnuy Index klucha
	push	bx	;Key
	call	_FileOpen
	push	ax	;_iFile
	mov	ax,offset _CreateEr
	segcs	mov	OpenEr,ax
	segcs	mov	OpenAX,5B00
	segcs	mov	OpenDX,10
	call	_FileOpen
;-----------------------------------------
	push	cs
	pop	ds
;-----------------------------------------
	mov	_oFile,ax
	pop	ax
	mov	_iFile,ax
_SetSize:
	xchg	ax,bx
        xor	ax,ax
	cwd
	xchg	ax,cx
	mov	bx,_iFile
        mov	ax,4202
        int	21
	mov	di,offset _Sfile
	stosw
	xchg	ax,dx
	stosw
        xor	ax,ax
	cwd
	xchg	ax,cx
        mov	ax,4200
        int	21
;-----------------------------------------
	pop	bx
	shl	bx,2
;-----------------------------------------
	mov	ax,[bx+2+offset _ModeProc]
;-----------------------------------------
	test	ax,ax
	jz	@@Set
	push	bx
	call	ax
	pop	bx
	jz	@@Set
	mov	si,offset _FormatEr
	call	_errPrint
@@Set:
	mov	ax,[bx+offset _ModeProc]

	test	ax,ax
	jz	@@Ret
	call	ax
@@Ret:
	.exit	0

_2Hex		proc	near
	mov	cx,4000
@@SetBuff:
	mov	si,offset _Buff
	lea	dx,[si]
	call	_Read
	xchg	ax,cx
	jcxz	@@Ret
	push	cx
	lea	di,[si+4000]
	lea	dx,[di]
@@Lodsw:
	xor	ax,ax
	lodsb
	call	_ax2hex
	stosw
	loop	@@Lodsw
@@Write:
	pop	cx
	push	cx
	shl	cx,1
	call	_Write
	pop	cx
	cmp	cx,4000
	jz	@@SetBuff
@@Ret:
	ret
endp
SetSZ	_2Hex

_Bin2Hex	proc	near
	xchg	ah,dl
	call	_ax2hex
	xchg	ax,dx
_ax2hex		proc	near
	aam	10
	call	_al2hex
	xchg	ah,al
_al2hex		proc	near
	add	al,30
	cmp	al,39
	jle	@@Ret
	add	al,7
@@Ret:
	ret
endp
endp
endp

_MoveData	proc	near
	mov	cx,4000
@@Strm2Txt10:
	mov	dx,offset _Buff
	call	_Read
	push	ax
	xchg	ax,cx
	jcxz	@@Ret
	mov	dx,offset _Buff
	call	_Write
	pop	cx
	cmp	cx,4000
	jz	@@Strm2Txt10
@@Ret:
	ret
endp

SetSZ	_MoveData

_Txt2Un		proc	near
	mov	si,offset _Buff
	mov	bx,4000
	lea	cx,[bx]
	lea	di,[si+bx]
	lea	dx,[si]
	call	_Read
        lea     dx,[di]
	push	ax
	xchg	ax,cx
	jcxz	@@Ret
@@Loop:
	xor	ax,ax
	lodsb
	call	Char2unik
	stosw
	Loop	@@Loop
	pop	cx
	shl	cx,1
	call	_Write
	cmp	cx,8000
	jz	_Txt2Un
@@Ret:
	ret
endp

Char2unik	proc	near
	cmp	al,'z'+1
	jnc	@@20S10
	ret
@@20S10:
	cmp	al,0F0
	jnz	@@20S20
	mov	ax,401
	ret
@@20S20:
	cmp	al,0F1
	jnz	@@20S30
	mov	ax,451
	ret
@@20S30:
	cmp	al,0FCh
	jnz	@@20S40
	mov	ax,2116
	ret
@@20S40:
	cmp	al,''
	ja	@@20S50
	add	ax,410-80
	ret
@@20S50:
        add	ax,440-0E0
	ret
endp
SetSZ	_Txt2Un

_Un2Txt		proc	near
	mov	si,offset _Buff
	mov	cx,8000
	lea	di,[si]
	lea	dx,[si]
	call	_Read
	push	ax
	xchg	ax,cx
	jcxz	@@Ret
	shr	cx,1
@@Lodsw:
	lodsw
	call	Uni2Char
	stosb
	loop	@@Lodsw
	mov	dx,offset _Buff
	pop	bx
	lea	cx,[bx]
	shr	cx,1
	call	_Write
	cmp	cx,4000
	jz	_Un2Txt
@@Ret:
	ret
endp

Uni2Char	proc	near
	cmp	ax,401
	jnz	@@10S10
	mov	al,0F0
	ret
@@10S10:
	cmp	ax,451
	jnz	@@10S20
	mov	al,0F1
	ret
@@10S20:
	cmp	ax,2116
	jnz	@@10S30
	mov	al,0FCh
	ret
@@10S30:
	cmp	ax,"z"
	ja	@@S20
	ret
@@S20:
	cmp	ax,410
	jb	@@Set20
	cmp	ax,43F
	ja	@@S30
	sub	ax,390
	ret
@@S30:
	cmp	ax,44F
	ja	@@Set20
	sub	ax,360
	ret
@@Set20:
	mov	al,20
	ret
endp

SetSZ	_Un2Txt


_IsStream	proc	near
	call	_IsNop
	call	_RetSize
	mov	di,offset _Buff
	xor	bx,bx
	not	bx
	lea	si,[di]
	push	ax dx
	test	dx,dx
	jz	@@Short
	cmp	dx,1
	jg	@@Long
	test	ax,ax
	jnz	@@Long
@@Short:
	mov	cx,3
	lea	ax,[bx]
	stosb
	pop	ax ax
	sub	ax,cx
	stosw
	jmp	@@ReadCompare
@@Long:
	mov	cx,7
	lea	ax,[bx]
;----------------------
	stosw
	stosb
	pop	dx ax
	sub	ax,cx
	sbb	dx,0
	stosw
	xchg	ax,dx
	stosw
@@ReadCompare:
	lea	dx,[di]
	push	cx
	call	_Read
	pop	cx
	rep	cmpsb
	ret
endp

_IsUnikode	proc	near
	call	_IsNop
	mov	dx,offset _Buff
	mov	cx,2
	call	_Read
	mov	ax,_Buff
	inc	ah
	inc	ax
	jnz	@@Ret
	call	_RetSize
@@Ret:	
	ret
endp

_IsNop		proc	near
	call	_RetSize
	add	ax,dx
	jo	@@Ret
	jnz	@@Ret
	mov	dx,offset _Fish
	call	_Print
	.Exit	0
@@Ret:
	cmp	ax,ax
	ret
endp

_SetUnikode	proc	near
	mov	ax,0FEFF
	mov	di,offset _Buff
	lea	dx,[di]
	stosw
        mov     cx,2
	call	_Write
	cmp	ax,ax
	ret
endp

_SetStream	proc	near
	xor	ax,ax
	not	ax
	mov	di,offset _Buff
	stosw
	stosb
	call	_RetSize
	stosw
	xchg	ax,dx
	stosw
	mov	dx,offset _Buff
	test	ax,ax
	jnz	@@Write
@@Short:
	dec	di
	dec	di
	inc	dx
	inc	dx
;	mov	dx,offset _Buff+2
@@Write:
	lea	cx,[di]
	sub	cx,dx
	call	_Write
	cmp	ax,ax
	ret
endp

_Sfile	label	dword

	dw	?,?

_Err		db	"訡: ",24
_WriteEr	db	6," 䠩",0Dh,0A,24
_ReadEr		db	4,"⥭ 䠩",0Dh,0A,24
_CreateEr	db	2,"ᮧ 䠩",0Dh,0A,24
_OpenEr		db	3," 䠩",0Dh,0A,24
_FormatEr	db	5,"ଠ 䠩",0Dh,0A,24
_CmdEr		db	1," ப",0Dh,0A,24
_Fish		db	"⮩ 室騩 䠩",0Dh,0A,24

_Use	db	"ᯮ짮:",0Dh,0A
	db	"lineutil  筨 ਥ",0Dh,0A
        db	" ८ࠧ:",0Dh,0A
	db	"+h bin  hex",0Dh,0A
	db	"+s text  stream",0Dh,0A
	db	"-s stream  text",0Dh,0A
	db	"+u cp866 text  unikode",0Dh,0A
	db	"-u unikode  text cp866",0Dh,0A,24

Hello	db	"३  - ⨫  ப",0Dh,0A
	db	" 楫 ᯮ짮  । 1",0Dh,0A,24

_CMDstb	db	"CMDLINE="
_CMDstbSZ	= $-offset _CMDstb
_CMDmod	db	"+h+s-s+u-u/?"
_ModCount	= ($-offset _CMDmod)/2
_ModeProc	label	near
		;dw	offset _2Als,_IsMD
		dw	offset _2Hex,_IsNop
		dw	offset _MoveData,_SetStream
		dw	offset _MoveData,_IsStream
		dw	offset _Txt2Un,_SetUnikode
		dw	offset _Un2Txt,_IsUnikode
OpenNameOfs	dw	?
OpenNameSeg	dw	?
OpenModeName	db	?
_Buff	label	word
end
